;Program for detektering av videosgnaler samt automatisk start og stopp av videoopptager.
;Utganger/Innganger:
;Porta,4 videosignal inn 15,625 Khz
;Portb,3 utg. for indikering av videosignal
;Portb,4 start av opptak p videospiller
;Portb,5 stopp av opptak p videospiller
;Portb,6 varsel tone for start og stopp av opptak (hyttaler)

;Krystall frekvensen m vre 4 Mhz.
;OBS!!! watchdog timeren er p !!!
;Programmet er utviklet av Sondre Danielsen



LIST    P=16f84



_CP_ON                       EQU     H'000F'
_CP_OFF                      EQU     H'3FFF'
_PWRTE_ON                    EQU     H'3FF7'
_PWRTE_OFF                   EQU     H'3FFF'
_WDT_ON                      EQU     H'3FFF'
_WDT_OFF                     EQU     H'3FFB'
_LP_OSC                      EQU     H'3FFC'
_XT_OSC                      EQU     H'3FFD'
_HS_OSC                      EQU     H'3FFE'
_RC_OSC                      EQU     H'3FFF'
PORTA                        EQU     H'0005'
PORTB                        EQU     H'0006'
OPTION_REG                   EQU     H'0081'
STATUS                       EQU     H'0003'

__CONFIG       _CP_OFF & _PWRTE_ON & _WDT_ON & _XT_OSC


teller1	equ	0c		
teller2 equ	0d
teller3 equ	0e
teller4	equ	0f
synk	equ	10
teller5	equ	11
vid	equ	12
var1	equ 	13
lyd1	equ	14
lyd2	equ	15
lyd3	equ	16
lyd4	equ	17			

	bsf	3,5		;bank 1
	clrf	portb		;setter portb til utg	
	movlw	b'00001010'	;setter option register
	movwf	option_reg
	bcf	3,5		;bank 0
	clrf 	portb		
	clrf	synk

	btfsc	var1,0		;stopper opptak hvis videoen tar opp
	goto	stopp

start	call	video		;tester om det er videosignal p inng.
	btfss	vid,0
	goto	start
	
	bsf	portb,4		;starter opptak
	movlw	.2		;hvor lenge opptaksbryteren skal holdes inne
	call	wait
	bcf	portb,4
	call	tone2		;gir lyd sekvens ved oppstart av opptak
	movlw	.1
	call	wait
	call	tone2
	bsf	var1,0
	bsf	var1,1
	
s1	bsf	var1,1
	call	video		;tester om det fortsatt er videosignal
	btfsc	vid,0
	goto	s1
	
stopp	btfss	var1,1
	goto	st1
	bcf	var1,1
	movlw	.3		;venter i 3 sek opptaket stoppes
	call	wait
	call	video		;tester om det fortsatt er videosignal
	btfsc	vid,0
	goto	s1

st1	bsf	portb,5		;stopper opptak
	movlw	.2		;hvor lenge stopp bryteren skal holdes inne
	call	wait
	bcf	portb,5
	bcf	var1,0
	call	tone1		;gir et kort lydsignal ved stopp av opptak
	goto	start


	
;---------Lyd til hyttaler-----

tone2	
	movlw	.37		;Pulserende tone 4x med varierende tone, tallet bestemmer tonehyden
	movwf	lyd4
	call	lyd
	movlw	.39
	movwf	lyd4
	call	lyd
	movlw	.37
	movwf	lyd4
	call	lyd
	movlw	.39
	movwf	lyd4
	call	lyd
	return

tone1	movlw	.37		;Enkel kort tone, tallet bestemmer tone hyden
	movwf	lyd4

lyd	movlw	.16		;Hvor lenge lyden skal vare
	movwf	lyd2
lyda	movlw	.69		;Hvor lenge lyden skal vare
	movwf	lyd1
lydb	bsf	portb,6
	call	lydc
	bcf	portb,6
	call	lydc
	decfsz	lyd1
	goto 	lydb
	decfsz	lyd2
	goto	lyda
	return


lydc	movfw	lyd4		;Tonen p lyden 25
	movwf	lyd3
lydd	clrwdt
	decfsz	lyd3
	goto	lydd
	return



;--- Rutine som tester videosignalet 100 ganger ---

;returnerer med 0x01 i vid reg. hvis 80 % eller flere av testene er ok
;returnerer med 0x00 i vid reg. hvis 79 % eller ferre av testene er ok 

video	clrf	vid
	movlw	.100
	movwf	teller5		;teller5 settes til 100
v1	call	test		;tester videosignal
	btfsc	synk,0
	incf	vid		;ker vid reg. hvis ok
	decfsz	teller5		;decrementerer teller 5
	goto	v1		;gr til v1 inntil testen er utfrt 100 ganger
	
	movlw	.80		;tester om vid er 80 eller mer
	subwf	vid,0
	btfsc	status,0
	goto	vok
	bcf	portb,3			
	clrf	vid		;vid < 80  sett vid til 0x00
	return
vok	bsf	portb,3		
	bsf	vid,0		;vid > 80  sett vid til 0x01	
	return
	




;--- Rutine som teller antall synk pulser ---

;returnerer med synk=0x01 nr det er et videosignal p inngangen
;returnerer med synk=0x00 nr det ikke er videosignal p inngangen.

test	clrwdt			;clear watchdog timer
t1	clrf	synk
	btfsc	porta,4		;vent p lav inng.
	goto	t1
t2	btfss	porta,4		;vent p hy inng.
	goto	t2		
t3	incf	synk		;ker synk reg.
	btfsc	porta,4		;venter p lav inng.
	goto	t3		
t4	incf	synk		;ker synk reg.
	btfss	porta,4		;venter p hy inng.
	goto	t4

	movlw	.16		;sjekker om synk er strre enn 16
	subwf	synk,0		;hvis ikke g til av
	btfss	status,0
	goto	nsynk
	movlw	.19		;sjekker om synk er lavere enn 19 
	subwf	synk,0		;hvis ikke g til av
	btfsc	status,0
	goto	nsynk
	
	bsf	synk,0		;synk er >16 og synk <19
	return
nsynk	clrf	synk
	return

	


;---- venterutine w sekunder ------

wait	movwf	teller3
loop3	call	sekund
	decfsz	teller3
	goto	loop3
	return



;---- venterutine 1 sekund ------

sekund	movlw	.4			;4 ved 4 Mhz krystall
	movwf	teller4
loop4	movlw	.248			;B	248		
	movwf	teller2
loop2	movlw	.251			;A	251
	movwf	teller1
loop1	clrwdt				;clear watch dog timer
	decfsz	teller1
	goto	loop1
	decfsz	teller2
	goto	loop2
	decfsz	teller4
	goto	loop4			
	return



	END


